package models

type AdminUser struct {
	Id           int    `gorm:"PRIMARY_KEY;AUTO_INCREMENT" json:"id"` // 管理员用户 ID
	Mobile       string `json:"mobile"`
	Password     string `json:"-"`
	IsSuperAdmin bool   `gorm:"column:is_super_admin" json:"is_super_admin"` // 是否为超级管理员
	Status       int8   `json:"status"`                                      // 状态 0.无效 1.有效
	CreateTime   int64  `gorm:"column:ctime" json:"ctime"`                   // 创建时间
	ModifyTime   int64  `gorm:"column:mtime" json:"mtime"`                   // 修改时间
}

func (AdminUser) TableName() string {
	return "sgj_user_admin"
}
