package models

type OrgApp struct {
	Id         int   `gorm:"PRIMARY_KEY;AUTO_INCREMENT" json:"id"` // ID
	AppType    int   `gorm:"column:app_type" json:"app_type"`      // 应用类型 1.病友经营；2.科普号；3.血透经营；4.慢病管理
	Creator    int   `json:"creator"`                              // 创建者，即管理员用户的 id
	OrgId      int   `gorm:"column:org_id" json:"org_id"`
	Status     int8  `json:"status"`                    // 状态 0.无效 1.有效 2.禁用
	CreateTime int64 `gorm:"column:ctime" json:"ctime"` // 创建时间
	ModifyTime int64 `gorm:"column:mtime" json:"mtime"` // 修改时间
}

func (OrgApp) TableName() string {
	return "sgj_user_org_app"
}
